#coding=utf-8
#版本: 1.2
#如果您觉得好用,支持下作者的插件: https://forum.cocos.org/t/sublime-ctrl-d/92184/71

import os,sys
import os.path
import shutil
import json
import hashlib
import socket
import platform
from ftplib import FTP            #加载ftp模块
from mimetypes import guess_type, add_type


#---------------------------------------------------
#-- 				配置
#游戏配置
package_url = "http://127.0.0.1/version/"

#ftp服务器地址
ftp_ip 	 	= "127.0.0.1"
ftp_port 	= "21"
ftp_user 	= "user"
ftp_key  	= "my_passkey****"	
ftp_mode    = 1                     #连接模式 0主动 1被动

#creator 路径
reatorApp	= "/Applications/CocosCreator.app/Contents/MacOS/CocosCreator"

#脚本工作目录
game_dir 			= sys.path[0]
backup_dir 			= os.path.join(game_dir,'_up_game_dir','back')
upload_dir 			= os.path.join(game_dir,'_up_game_dir','upload')
build_dir 			= os.path.join(game_dir,"build","jsb-link")
recent_upload_dir 	= os.path.join(game_dir,'_up_game_dir','recent_upload')
remote_back_dir 	= os.path.join(game_dir,'_up_game_dir',"remote_back")
configFile 			= os.path.join(game_dir,'_up_game_dir',"up_game_file.json")

isCode 	= ('gbk' if (platform.system() == "Windows") else 'utf-8')

#---------------------------------------------------
#-- 				通用方法

#创建路径下的文件夹
def createDir(paht):
	if len(os.path.split(paht)) > 1:
		if not os.path.isdir(os.path.split(paht)[0]):
			os.makedirs(os.path.split(paht)[0])
	elif not os.path.isdir(paht):
		os.makedirs(paht)


#获得目录下所有文件列表
def getFileList(dir,fileList):
	if os.path.isfile(dir):
		fileList.append(dir.decode(isCode))
	elif os.path.isdir(dir):  
		for s in os.listdir(dir):
			newDir=os.path.join(dir,s)
			getFileList(newDir, fileList)  
	return fileList

#保存Json
def saveJson(filePath,data):
	createDir(filePath)
	json_file = open(filePath,"wb")
	text = json.dumps(data,indent=4)
	json_file.write(text)
	json_file.close()

#读取Json
def loadJson(filePath):
	if os.path.exists(filePath) :
		json_file = open(filePath)
		data = json.load(json_file)
		json_file.close()
		return data
	else:
		return False

#获取MD5
def getMD5(file_path):
	md5 = None
	if os.path.isfile(file_path):
		f = open(file_path,'rb')
		md5_obj = hashlib.md5()
		md5_obj.update(f.read())
		hash_code = md5_obj.hexdigest()
		f.close()
		md5 = str(hash_code).lower()
	return md5

#文件夹对比
def fc(new_dir,old_dir):
	c_list = []
	fileList = getFileList(new_dir,[])
	for n_file in fileList:
		o_file = old_dir + n_file.split(new_dir)[1]
		if not os.path.isfile(o_file) or getMD5(n_file) != getMD5(o_file) :
			c_list.append(n_file)
	return c_list #差异的文件

	
#复制文件到指定目录
def copyFileTo(fileList,rDir,tDir):
	for r_file in fileList:
		if r_file.find("DS_Store") != -1 :
			continue
		t_file = tDir + r_file.split(rDir)[1]
		createDir(t_file)
		shutil.copyfile(r_file,t_file)

#是否文本文件
def isTextKind(file, trace=False):
	add_type('text/x-python-win', '.pyw')
	mimetype, encoding = guess_type(file, strict=False)
	mimetype = mimetype or '?/?'
	maintype = mimetype.split('/')[0]
	if trace: print(maintype, encoding or '')
	return maintype == 'text' and encoding == None


"""	
ftp 断线重连
"""
def reconnection(ftp,func):
	 try:  
	 	func() 							  #执行的函数
 	 except:  
 	 	# ftp.quit()
 	 	print(u"断线重连...")
 	 	ftp.set_pasv(ftp_mode)            #连接模式 0主动 1被动
 	 	ftp.connect(ftp_ip,ftp_port)      #连接的ftp sever和端口
 	 	ftp.login(ftp_user,ftp_key)       #连接的用户名，密码x
 	 	print(u"断线重连...ok")
 	 	reconnection(ftp,func)			  #重新执行的函数

"""	
是否存在远程目录
"""
def isExistRemotesDir(ftp,dir,isCreateDir):  
	try:
		ftp.cwd(dir)  
	except:
		if isCreateDir :
			try:
				ftp.mkd(dir)                 #新建远程目录
				return True
			except:
				return True
		return False
	return True

"""
使用FTP上传一个文件
"""
def uploadOne(ftp,localname, localpath, remotename):
	if isTextKind(localname):
		localfile = open(localpath, 'rb')
		#STOR表示上传
		ftp.storlines('STOR ' + remotename, localfile)
		localfile.close()
	else:
		localfile = open(localpath, 'rb')
		ftp.storbinary('STOR ' + remotename, localfile)
		localfile.close()
	
"""
使用FTP下载一个文件
remotename:远程文件
localpath:本地文件
"""
def downloadOne(ftp, remotename, localpath):
	createDir(localpath)
	if isTextKind(remotename):
		localfile = open(localpath, 'w')
		def callback(line): localfile.write(line + '\n')
		#RETR表示下载命令 callback表示回调
		ftp.retrlines('RETR ' + remotename, callback)
		localfile.close()
	else:
		localfile = open(localpath, 'wb')
		ftp.retrbinary('RETR ' + remotename, localfile.write)
		localfile.close()


"""	
尝试删除所有远程文件为移除无效文件
"""
def cleanRemotes(ftp,dir):
	if not isExistRemotesDir(ftp,dir,False):
		return 
	#进入远程目录
	ftp.cwd(dir)    
	for remotename in ftp.nlst():
		try:
			ftp.cwd(dir)   
			ftp.delete(remotename)
		except:
			# remote dir listing # remote file delete
			cleanRemotes(ftp,dir+'/'+remotename)
	ftp.cwd(dir)
	ftp.rmd(dir)
			
"""
从远程下载所有的文件
"""
def downloadDir(ftp,remote_dir,download_dir):
	if not isExistRemotesDir(ftp,remote_dir,False):
		return 
	ftp.cwd(remote_dir)       
	remotefiles = ftp.nlst() # nlst is remote listing
	for remotename in remotefiles:
		if remotename in ('.', '..'): continue
		localpath = os.path.join(download_dir, remotename)
		#print('downloading', remotename, 'to', localpath, 'as', end=' ')
		if os.path.splitext(remotename)[1] != "" :
			ftp.cwd(remote_dir) 
			reconnection(ftp,lambda: downloadOne(ftp,remotename, localpath)) #文件
			print("download:",remote_dir+"/"+remotename)
		else:
			downloadDir(ftp, remote_dir+"/"+remotename ,localpath)

	
"""
上传一个目录
"""
def uploadDir(ftp,remote_dir,local_dir,forbidUpFile):  
	isExistRemotesDir(ftp,remote_dir,True)
	ftp.cwd(remote_dir)     
	localfiles = os.listdir(local_dir) # listdir is local listing
	for localname in localfiles:
		localpath = os.path.join(local_dir, localname)
		
		
		if os.path.isdir(localpath):
			uploadDir( ftp ,remote_dir+"/"+localname, localpath ,forbidUpFile) #目录

		elif forbidUpFile == 0 or forbidUpFile.has_key(localpath):
			
			def upData():
				print('uploading:'+remote_dir+"/"+localname)	
				ftp.cwd(remote_dir) 
				uploadOne(ftp,localname, localpath, localname) #文件

			reconnection(ftp,upData)

"""
打印文件夹列表
"""
def printFtpDirList(ftp,remote_dir,gap_str):  
	if not isExistRemotesDir(ftp,remote_dir,False):
		return 
	ftp.cwd(remote_dir)       
	remotefiles = ftp.nlst() # nlst is remote listing
	for remotename in remotefiles:
		if remotename in ('.', '..'): continue
		if os.path.splitext(remotename)[1] == "" :
			print gap_str+"+ "+remotename
			printFtpDirList(ftp, remote_dir+"/"+remotename,gap_str+"   ")
		else:
			print gap_str+remotename

		
#---------------------------------------------------
"""		 流程逻辑
			
1.获取热更新文件夹名字和版本号
2.复制对比文件到临时文件夹(可选)
3.对比修改过的图片或代码复制到准备上传的文件夹
4.生成MD5配置文件
5.连接FTP 下载旧的更新文件备份
6.删除服务器旧的更新文件并上传
"""


# 输入配置信息
def loadConfig():

	data = loadJson(configFile)
	if not data :
		data = {"var" : "1.0.0","name" : "__nil_dir__","isBackup" : False}

		if len(sys.argv)>1 :
			data["name"] = sys.argv[1]
		else:

			dirName = game_dir.split(os.path.sep)
			dirName = dirName[len(dirName)-1]
			data["name"] = raw_input(unicode("首次热更新请输入游戏文件夹名(不输入默认为" + dirName + "): \n",'utf-8').encode(isCode))
			if data["name"] == "" :
				data["name"] = dirName

		data["isFirstStart"] = True #是否首次启动
		data["firstStartDir"] = game_dir #记录首次启动脚步的文件夹,防止拷贝新工程时忘了删除热更新的临时文件

	else:
		data["isFirstStart"] = False

	saveJson(configFile,data)


	# 读取配置是否分模块
	manifestCfg = loadJson(os.path.join(game_dir,"assets","project.manifest"))
	if manifestCfg :
		data["manifestCfg"]	 = manifestCfg
		data["isUseModular"] = manifestCfg["isUseModular"]
	else:
		data["isUseModular"] = False


	print(u"#-------------------name:"+data["name"]+" version:"+data["var"] +"----------------------#")
	if data["firstStartDir"] != game_dir :
		print(u"拷贝新工程时是否忘了删除旧工程热更新的临时文件？")
		print(u"请删除该脚本目录下的<_up_game_dir>文件夹后再继续..")
		print(u"之前的工作目录是:" + data["firstStartDir"])
		print(u"退出..")
		raw_input()
		sys.exit()
	version = raw_input(unicode("请输入更新版本号(不填写默认使用上次版本号):\n",'utf-8').encode(isCode))
	isBackup  = raw_input(unicode("是否刷新src与res的对比文件(不填写默认不刷新,1刷新):\n",'utf-8').encode(isCode))

	isUpNewFile 	= "0"
	isBuildAssets 	= "0"

	# 刷新资源后强制全部上传
	if isBackup != "1" :
		isUpNewFile = raw_input(unicode("是否只上传新修改或新增的文件(不填写默认“是”，0.否,1.是):\n",'utf-8').encode(isCode))
		isBuildAssets = raw_input(unicode("是否重新构建资源(不填写默认“是”，0.否,1.是):\n",'utf-8').encode(isCode))
	else:
		isUpNewFile 	= "0"
		isBuildAssets 	= data["isUseModular"] and "1" or "0"
	
	if len(version)==0 :
		version = data["var"]
	else:
		data["var"] = version
		saveJson(configFile,data)
		
	if isBackup == "1":
		data["isBackup"] = True
	else:
		data["isBackup"] = False

	data["isUpNewFile"] = isUpNewFile == "1" or isUpNewFile == ""
	data["isBuildAssets"] = isBuildAssets == "1" or isBuildAssets == ""

	return data



#刷新游戏对比文件
def backupDir(cfg):
	#将备份目录删掉
	if os.path.isdir(backup_dir):
		shutil.rmtree(backup_dir)
	#重新备份文件
	os.makedirs(backup_dir)
	shutil.copytree(os.path.join(game_dir,"assets"),os.path.join(backup_dir,"assets"))

	shutil.copytree(os.path.join(build_dir,"src"),os.path.join(backup_dir,"src"))
	shutil.copytree(os.path.join(build_dir,"res"),os.path.join(backup_dir,"res"))

	# 模块文件夹
	# moduledir = os.path.join(build_dir,"_moduleDir")
	# toResdir = os.path.join(backup_dir,"res","raw-assets")
	# if cfg["isUseModular"] and os.path.isdir(moduledir):
	# 	fileList = getFileList(moduledir,[]);
	# 	for file in fileList:
	# 		createDir(file)
	# 		toPath = file.replace(moduledir,toResdir);
	# 		if not os.path.isfile(toPath):
	# 			shutil.move(file,toPath);	
			
	
#复制差异的文件
def copyFcFile(cfg):

	#清空上次更新的目录
	if os.path.isdir(upload_dir):
		shutil.rmtree(upload_dir)
	
	#清空对比差异代码目录
	if os.path.isdir( os.path.join(backup_dir,"up_src") ):
		shutil.rmtree(os.path.join(backup_dir,"up_src"))
		

	# 模块文件夹的文件还原到 H5-hj/build/jsb-link/res/raw-assets
	moduledir = os.path.join(build_dir,"_moduleDir")
	toResdir = os.path.join(build_dir,"res","raw-assets")
	if cfg["isUseModular"] and os.path.isdir(moduledir):
		fileList = getFileList(moduledir,[]);
		for file in fileList:
			createDir(file)
			toPath = file.replace(moduledir,toResdir);
			if not os.path.isfile(toPath):
				shutil.move(file,toPath);		

	#没有原文件不进行比较
	if os.path.isdir(backup_dir) :
		f_list = fc(os.path.join(build_dir,"res"),os.path.join(backup_dir,"res"))			  	#对比差异文件
		copyFileTo(f_list, os.path.join(build_dir,"res") ,os.path.join(upload_dir,"assets","res")) 		#复制差异文件
			
		f_list = fc(os.path.join(build_dir,"src"),os.path.join(backup_dir,"src"))
		copyFileTo(f_list, os.path.join(build_dir,"src") ,os.path.join(upload_dir,"assets","src"))
		


def newVecsionFile(cfg,useFileMap,fileList,moduleName="",path=None):
	game_name = cfg["name"]
	version = cfg["var"]

	#生成MD5配置
	cfg = {
		"baseUrl" : package_url + game_name,
		'packageUrl' : package_url + game_name + "/assets/",
		'remoteManifestUrl' : package_url + game_name + "/"+moduleName+"project.manifest",
		'remoteVersionUrl' : package_url + game_name + "/"+moduleName+"version.manifest",
		'isUseModular' : cfg["isUseModular"],
		'version': version,
		"engineVersion" : "3.x dev",
		'searchPaths' :[],
		'assets' : {},
		'moduleName' : moduleName
	}
	#生成简化配置
	saveJson(os.path.join(upload_dir,moduleName+"version.manifest"),cfg)
	
	#生成MD5配置
	assetsPath = os.path.join(upload_dir,"assets")
	fileList = getFileList(assetsPath,[])
	for file in fileList:
		_file = file.split(assetsPath+os.path.sep)[1].replace('\\','/')
		print(_file," ",path)
		if not useFileMap.has_key(_file) and ( path == None or _file.find(path) != -1 ):
			useFileMap[_file] = True
			md5 = getMD5( file )
			cfg["assets"][_file] = {"md5" : md5}


	saveJson(os.path.join(upload_dir,moduleName+"project.manifest"),cfg)
	print u"\n\n#------------------生成配置的文件:"+moduleName+"-------------------"
	print json.dumps(cfg,indent=4)



#生成热更新配置文件	
def saveVecsionFile(cfg):

	assetsPath = os.path.join(upload_dir,"assets")
	fileList = getFileList(assetsPath,[])

	buildResDir = os.path.join(build_dir,"res","raw-assets")
	useFileMap = {}

	# 使用模块
	if cfg["isUseModular"] :

		# 生成模块的配置文件
		gameDir = os.path.join(buildResDir,"game")
		if os.path.isdir(gameDir):
			for moduleName in os.listdir(gameDir):
				newVecsionFile(cfg,useFileMap,fileList,moduleName+"_","game/"+moduleName+"/");

		# 生成自定义模块配置文件		
		if cfg["manifestCfg"].has_key('customModules'):
			for moduleName in cfg["manifestCfg"]["customModules"] :
				newVecsionFile(cfg,useFileMap,fileList,moduleName.name+"_",moduleName.path);	
		
	newVecsionFile(cfg,useFileMap,fileList,"")	


#FTP 上传热更新文件
def upFileToFtp(cfg):
	socket.setdefaulttimeout(15)	  #连接超时设置
	ftp=FTP()                         #设置变量
	ftp.set_pasv(ftp_mode)			  #连接模式 0主动 1被动
	ftp.connect(ftp_ip,ftp_port)      #连接的ftp sever和端口
	ftp.login(ftp_user,ftp_key)       #连接的用户名，密码x
	remote_dir = '/'+cfg["name"]
	
	isUpload = "1"
	#1.第一次启动咨询是否覆盖服务器原有的文件夹
	if cfg["isFirstStart"] and isExistRemotesDir(ftp,remote_dir,False):
		isUpload  = raw_input(unicode("服务器上已经有相同目录<"+ cfg["name"] +">是否覆盖?  (填:1 覆盖,0 退出):\n",'utf-8').encode(isCode))

	#2.开始上传文件
	if isUpload == "1" :

		#备份服务器上更新文件
		if cfg["isFirstStart"] :
			print u"\n\n#---------------开始备份服务器旧文件-------------------"
			if os.path.isdir(remote_back_dir):
				shutil.rmtree(remote_back_dir)
			os.makedirs(remote_back_dir)
			downloadDir(ftp,remote_dir,remote_back_dir)
			print u"备份完成:",remote_back_dir

		print u"\n\n#------------------开始上传-------------------"


		#上传完整的文件
		if not cfg["isUpNewFile"] :
			reconnection(ftp,lambda :cleanRemotes(ftp,remote_dir+"_temp"))		 #清除远程临时目录
			uploadDir(ftp,remote_dir+"_temp",upload_dir,0) #上传到临时文件夹
			print(u"正在删除旧文件..")
			reconnection(ftp,lambda :cleanRemotes(ftp,remote_dir))				 #清除远程更新目录
			ftp.rename(remote_dir+"_temp",remote_dir)	 #临时文件夹重命名回正式名
		#上传新增的文件
		else :
			f_list = fc(upload_dir,recent_upload_dir)	 #对比差异文件
			cFiles  = {}
			print(u"【准备上传的新增文件】")
			for r_file in f_list:
				print r_file
				cFiles[r_file] = True
			print("\n")
			uploadDir(ftp,remote_dir,upload_dir,cFiles) #上传到临时文件夹



		
		print u"\n\n#---------------上传完成,服务器目录结构-------------------"
		print "#-- "+remote_dir+"/.."
		# printFtpDirList(ftp,remote_dir,"")
		
	#退出ftp
	ftp.quit()     

	#清空上次更新的目录
	if os.path.isdir(recent_upload_dir):
		shutil.rmtree(recent_upload_dir)

	#更改上次更新的目录名 "upload_dir" -> "recent_upload_dir"
	os.rename(upload_dir,recent_upload_dir)                   	
	
# 构建资源
def buildAssets(cfg):
	if cfg["isBuildAssets"]:
		os.system(reatorApp + " --path " + game_dir + ' --build "platform=android;debug=false"')


def init():
	#1.读配置
	cfg = loadConfig()
	#2.构建资源
	buildAssets(cfg)
	#3.刷新对比文件
	if not os.path.isdir(backup_dir) or cfg["isBackup"] :
		backupDir(cfg)
	#4.对比复制
	copyFcFile(cfg)
	#5.生成MD5配置文件
	saveVecsionFile(cfg)
	#6.备份/上传
	upFileToFtp(cfg)
	
init()
raw_input(unicode("\n更新完成,回车退出...",'utf-8').encode(isCode))
